import { Alert, useDataGrid } from '@/components';
import { useManagePostoAdmsContext } from '../hooks/useManagePostoAdmsContext';
import { useCallApi } from '@/hooks';
import { useCallback, useState } from 'react';
import { apiConfig } from '@/config/api.config';
import { toast } from 'sonner';
import {
  Dialog,
  DialogContent,
  DialogDescription,
  DialogFooter,
  DialogHeader,
  DialogTitle
} from '@/components/ui/dialog';
import { Button } from '@/components/ui/button';
import { doSaveLogActivity } from '@/actions/GlobalActions';

const API_URL = apiConfig.service_master_data;

const DeleteDialog = () => {
  const { showDeleteDialog, handleDeleteDialog, selectedPostoAdms } = useManagePostoAdmsContext();
  const { reload } = useDataGrid();
  const { DeleteData } = useCallApi();
  const [alert, setAlert] = useState({
    show: false,
    message: ''
  });

  const doDeletePostoAdm = useCallback(async () => {
    if (!selectedPostoAdms) {
      toast.error('No Postu Administrativo selected');
      return;
    }

    const response = await DeleteData(`${API_URL}/postoadms/delete/${selectedPostoAdms}/false`, {
      id: selectedPostoAdms
    });

    if (response?.status) {
      setAlert({ show: false, message: '' });
      handleDeleteDialog(false, null);
      toast.success('Success Delete Postu Administrativo');
      reload();
      const createActivity = {
        module: 'Manage Postu Administrativo',
        description: `Delete Postu Administrativo => ${selectedPostoAdms}`,
        action: 'D'
      };

      doSaveLogActivity(createActivity);
    } else {
      setAlert({ show: true, message: response?.message });
      toast.error('Failed Delete Postu Administrativo');
    }
  }, [selectedPostoAdms, DeleteData, handleDeleteDialog, reload]);

  return (
    <Dialog open={showDeleteDialog} onOpenChange={(open) => handleDeleteDialog(open, null)}>
      <DialogContent className="container-fixed max-w-md flex flex-col p-5 overflow-hidden [&>button]:hidden">
        <DialogTitle></DialogTitle>
        <DialogDescription></DialogDescription>
        <DialogHeader className="p-0 border-0 block">
          <Alert variant="warning">
            <h3 className="text-lg">Are you sure?</h3>
            <span className="text-sm">You will delete this data!</span>
          </Alert>
          {alert.show && (
            <Alert variant="danger">
              <h3>{alert.message}</h3>
            </Alert>
          )}
        </DialogHeader>
        <DialogFooter className="flex justify-end items-center gap-4 mt-3">
          <Button variant="outline" onClick={() => handleDeleteDialog(false, null)}>
            Cancel
          </Button>
          <Button variant="destructive" onClick={doDeletePostoAdm}>
            Delete
          </Button>
        </DialogFooter>
      </DialogContent>
    </Dialog>
  );
};

export default DeleteDialog;
